// ScriptorTypeDef.h
// File author: Bob "BS-er" Stewart
// bser@nycap.rr.com
// DLL scriptor - by Bob "BS-er" Stewart and John "Madcat" Semler

#ifndef _SCRIPTOR_TYPE_DEF
#define _SCRIPTOR_TYPE_DEF

#define LARGE_DLL

#include "ScriptUtils.h"

struct StepData
{
	short Instruction; // The switch-case branch that this step will use.
	short Item1; // These depend on the function used for this step.  They can be
	short Item2; // indices to handles, vectors, strings etc., or for other information.
	short Item3;
	short Item4;
};

struct ObjectiveStruct
{
	char s[150];
	inline const char& operator[](int n) const	{ return s[n]; }
	inline operator const char*() const { return s; }
};

struct NameStruct
{
	char s[40];
	inline char& operator[](int n) { return s[n]; }
	inline operator const char*() const { return s; }
	inline operator char*() const { return (char*)s; }
};


#define RandomRange 0.999999f
#define Interval 0.10f // time interval between DLL calls

#ifdef LARGE_DLL
#define OperationCount 1400
#define MaxRoutineCount 30
#define PosCount 48
#define IntegerCount 48
#define HandleCount 96
#define StringCount 200
#define ObjectiveCount 25
#else
#define OperationCount 1000
#define MaxRoutineCount 20
#define PosCount 32
#define IntegerCount 32
#define HandleCount 64
#define StringCount 150
#define ObjectiveCount 15
#endif


#endif