// bz2dep.cpp
// File author: Bob "BS-er" Stewart
// bser@nycap.rr.com
// DLL scriptor - by Bob "BS-er" Stewart and John "Madcat" Semler

#include <Windows.h>
#include "ScriptorTypeDef.h"
#include <math.h>
#include <string.h>
#include "bz2arrays.h"

class Loader
{
public:
	HMODULE VM;
	void Load()
	{
		VM = LoadLibrary("Missions/ScriptorVM2.dll");
		if (VM == 0)
		{
			VM = LoadLibrary("ScriptorVM3.dll");
		}
	}

	~Loader()
	{
		if (VM != 0)
		{
			FreeLibrary(VM);
		}
	}
};


class BZHandle
{
public:
	HMODULE Handle;
	BZHandle()
	{
		Handle = GetModuleHandle("bzone.exe");
		if (Handle == 0)
		{
			Handle = GetModuleHandle("bz2edit.exe");
		}
	}

	inline operator HMODULE() const { return Handle; }
};


Loader MissionLoader;



void DLLAPI InitialSetup(void)
{
}

bool DLLAPI Save(bool misnSave)
{
	return false;
}

bool DLLAPI Load(bool misnSave)
{
	return false;
}

bool DLLAPI PostLoad(bool misnSave)
{
	return false;
}

void DLLAPI AddObject(Handle h)
{
}

void DLLAPI DeleteObject(Handle h)
{
}

void DLLAPI Update(void)
{
}

void DLLAPI PostRun(void)
{
}

bool DLLAPI AddPlayer(DPID id, int Team, bool ShouldCreateThem)
{
	return false;
}

void DLLAPI DeletePlayer(DPID id)
{
}

EjectKillRetCodes DLLAPI PlayerEjected(Handle DeadObjectHandle)
{
	return DoGameOver;
}

EjectKillRetCodes DLLAPI ObjectKilled(int DeadObjectHandle,int KillersHandle)
{
	return DoGameOver;
}

EjectKillRetCodes DLLAPI ObjectSniped(int DeadObjectHandle,int KillersHandle)
{
	return DoGameOver;
}

char * DLLAPI GetNextRandomVehicleODF(int Team)
{
	return "ERROR";
}

void DLLAPI SetWorld(int nextWorld)
{
}

void DLLAPI ProcessCommand(unsigned long crc)
{
}

void DLLAPI SetRandomSeed(unsigned long seed)
{
}


static MisnExport misnExport;
MisnImport misnImport;


// ___________________________________________________________________________
MisnExport * __cdecl GetMisnAPI(MisnImport *import)
{
	MissionLoader.Load();
	if (MissionLoader.VM == 0)
	{
		BZHandle BZH;
		void (*AddObjective)(char *,long,float) =
			(void (__cdecl*)(char *,long,float)) GetProcAddress(BZH, "?AddObjective@@YAXPADJM@Z");
		AddObjective("ERROR   ERROR   ERROR\n\nRequired DLL ScriptorVM2.dll\nwas not found.", 0xFFFFFF00, 15);

		misnImport = *import;
		memset(&misnExport,0x00,sizeof(misnExport));
		misnExport.version = LATEST_DLL_VERSION;
		misnExport.VersionModifier = LATEST_DLL_VERSION_MODIFIER;
		misnExport.misnImport = &misnImport;
		misnExport.InitialSetup= InitialSetup;
		misnExport.Save = Save;
		misnExport.Load = Load;
		misnExport.PostLoad = PostLoad;
		misnExport.AddObject = AddObject;
		misnExport.DeleteObject = DeleteObject;
		misnExport.Update = Update;
		misnExport.PostRun = PostRun;
		misnExport.AddPlayer = AddPlayer;
		misnExport.DeletePlayer = DeletePlayer;
		misnExport.PlayerEjected = PlayerEjected;
		misnExport.ObjectKilled = ObjectKilled;
		misnExport.ObjectSniped = ObjectSniped;
		misnExport.GetNextRandomVehicleODF = GetNextRandomVehicleODF;
		misnExport.SetWorld = SetWorld;
		misnExport.ProcessCommand = ProcessCommand;
		misnExport.SetRandomSeed = SetRandomSeed;
		return &misnExport;
	}
	else
	{
		void (*SetMissionData)( StepData*, short, Vector*, NameStruct*,
								short*, short*, bool*, short*, 
								ObjectiveStruct*, bool*) =
		(void (__cdecl*)( StepData*, short, Vector*, NameStruct*,
						  short*, short*, bool*, short*, 
						  ObjectiveStruct*, bool*)) GetProcAddress(MissionLoader.VM, "SetMissionData");


		MisnExport* (*GetRealAPI)(MisnImport *import) =
			(MisnExport* (__cdecl*)(MisnImport *import)) GetProcAddress(MissionLoader.VM, "GetMisnAPI");

		SetMissionData
		(
			RoutineData,
			NumberOfRoutines,
			GlobalVectorArray,
			NameArray,
			GlobalRoutineSpeed,
			GlobalIntegerArray,
			GlobalRoutinePriority,
			RoutineOffset,
			ObjectiveArray,
			DebugText
		);

		return GetRealAPI(import);
	}
}


