// debug.h
// File author: Bob "BS-er" Stewart
// bser@nycap.rr.com
// DLL scriptor - by Bob "BS-er" Stewart and John "Madcat" Semler
// Thanks to Chuck "Greeny" Noble for help with console debug messages.

#ifndef _DEBUGHEADER
#define _DEBUGHEADER

#include "scriptutils.h"

#ifdef _BZDEBUG
#define _DEBUG_CMD_STR1( a, b, c, d, e, f ){CommandString1( a, b, c, d, e, f );}
#define _DEBUG_CMD_STR2( a, b, c, d, e, f ){CommandString2( a, b, c, d, e, f );}
#define _DEBUG_CMD_STR3( a, b, c, d, e, f ){CommandString3( a, b, c, d, e, f );}
#define _DEBUG_CMD_STR4( a, b, c, d, e, f ){CommandString4( a, b, c, d, e, f );}
#define _DEBUG_CMD_INT( a, b, c, d, e, f ){CommandInt( a, b, c, d, e, f );}
#else
#define _DEBUG_CMD_STR1(a, b, c, d, e, f  ) {}
#define _DEBUG_CMD_STR2( a, b, c, d, e, f ) {}
#define _DEBUG_CMD_STR3( a, b, c, d, e, f ) {}
#define _DEBUG_CMD_STR4( a, b, c, d, e, f ) {}
#define _DEBUG_CMD_INT(a, b, c, d, e, f  ) {}
#endif


void CommandString1(int Routine, char *Command, int i1, char* Name, int i2, int i3 )
{
	if (!DebugText[Routine])
		return;

	char szOut[60];

	sprintf(szOut, "Routine %i: %s,%i,\"%s\",%i,%i", Routine, Command, i1, Name, i2, i3);
	PrintConsoleMessage( szOut );
}

void CommandString2(int Routine, char *Command, int i1, char* Name, int i2, char* Name2 )
{
	if (!DebugText[Routine])
		return;

	char szOut[60];

	sprintf(szOut, "Routine %i: %s,%i,\"%s\",%i,\"%s\"", Routine, Command, i1, Name, i2, Name2);
	PrintConsoleMessage( szOut );
}

void CommandString3(int Routine, char *Command, char* Name, int i1, int i2, int i3)
{
	if (!DebugText[Routine])
		return;

	char szOut[60];

	sprintf(szOut, "Routine %i: %s,\"%s\",%i,%i,%i", Routine, Command, Name, i1, i2, i3);
	PrintConsoleMessage( szOut );
}

void CommandString4(int Routine, char *Command, char* Name1, char* Name2, int i1, int i2)
{
	if (!DebugText[Routine])
		return;

	char szOut[80];

	sprintf(szOut, "Routine %i: %s,\"%s\",\"%s\",%i,%i", Routine, Command, Name1, Name2, i1, i2);
	PrintConsoleMessage( szOut );
}

void CommandInt(int Routine, char *Command, int i1, int i2, int i3, int i4 )
{
	if (!DebugText[Routine])
		return;
	
	char szOut[60];

	sprintf(szOut, "Routine %i: %s,%i,%i,%i,%i", Routine, Command, i1, i2, i3, i4);
	PrintConsoleMessage( szOut );
}

#endif